Package org.zkoss.stateless.sul

## Interface IListcell<I extends IAnyGroup>

- All Superinterfaces:
    `IChildable<IListcell<I>,​I>`, `IChildrenOfInputgroup<IListcell<I>>`, `IComponent<IListcell<I>>`, `IHtmlBasedComponent<IListcell<I>>`, `ILabelElement<IListcell<I>>`, `ILabelImageElement<IListcell<I>>`, `IXulElement<IListcell<I>>`

      public interface IListcell<I extends IAnyGroup>
      extends ILabelImageElement<IListcell<I>>, IChildable<IListcell<I>,​I>

  Immutable `Listcell` component
  Author:
    katherine
  See Also:
    `Listcell`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `IListcell.Builder<I extends IAnyGroup>` | Builds instances of type `IListcell`.
    `static class` | `IListcell.Updater` | Builds an updater of type `IListcell` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static IListcell<IAnyGroup>` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getHflex()` | Return horizontal flex hint of this component.
    `default int` | `getSpan()` | Returns number of columns to span this cell.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default java.lang.String` | `getWidth()` | Returns the width of the component.
    `static <I extends IAnyGroup> IListcell<I>` | `of​(I... children)` | Returns the instance with the given any group children.
    `static <I extends IAnyGroup> IListcell<I>` | `of​(java.lang.Iterable<? extends I> children)` | Returns the instance with the given any group children.
    `static <I extends IAnyGroup> IListcell<I>` | `of​(java.lang.String label)` | Returns the instance with the given label.
    `static <I extends IAnyGroup> IListcell<I>` | `of​(java.lang.String label, java.lang.String image)` | Returns the instance with the given label and image.
    `static <I extends IAnyGroup> IListcell<I>` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static <I extends IAnyGroup> IListcell<I>` | `ofImage​(java.lang.String image)` | Returns the instance with the given image.
    `default IListcell` | `withHflex​(java.lang.String hflex)` | To control the size of Foot related components, please refer to `IListbox` and `IListheader` instead.
    `IListcell<I>` | `withSpan​(int span)` | Returns a copy of `this` immutable component with the specified `span`.
    `default IListcell` | `withWidth​(java.lang.String width)` | To control the size of Foot related components, please refer to `IListbox` and `IListheader` instead.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelElement

      `getLabel, withLabel`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILabelImageElement

      `getHoverImage, getIconSclass, getIconSclasses, getIconTooltip, getIconTooltips, getImage, isPreloadImage, withHoverImage, withIconSclass, withIconSclasses, withIconTooltip, withIconTooltips, withImage, withPreloadImage`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final IListcell<IAnyGroup> DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.sel.Listcell"`

      Specified by:
        `getWidgetClass` in interface `IComponent<I extends IAnyGroup>`

    - #### getWidth

          @Derived
          @Nullable
          default java.lang.String getWidth()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the width of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getWidth` in interface `IHtmlBasedComponent<I extends IAnyGroup>`

    - #### withWidth

          default IListcell withWidth​(@Nullable
                                      java.lang.String width)

      To control the size of Foot related components, please refer to `IListbox` and `IListheader` instead.
      Specified by:
        `withWidth` in interface `IHtmlBasedComponent<I extends IAnyGroup>`
      Parameters:
        `width` - The width of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getHflex

          @Derived
          @Nullable
          default java.lang.String getHflex()

      Description copied from interface: `IHtmlBasedComponent`
      Return horizontal flex hint of this component.

      Default: `null`

      Specified by:
        `getHflex` in interface `IHtmlBasedComponent<I extends IAnyGroup>`

    - #### withHflex

          default IListcell withHflex​(@Nullable
                                      java.lang.String hflex)

      To control the size of Foot related components, please refer to `IListbox` and `IListheader` instead.
      Specified by:
        `withHflex` in interface `IHtmlBasedComponent<I extends IAnyGroup>`
      Parameters:
        `hflex` - The horizontal flex hint.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getSpan

          default int getSpan()

      Returns number of columns to span this cell. Default: `1`.

    - #### withSpan

          IListcell<I> withSpan​(int span)

      Returns a copy of `this` immutable component with the specified `span`.

      Sets number of columns to span this cell.

      Parameters:
        `span` - Number of columns to span this cell.

        Default: `1`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static <I extends IAnyGroup> IListcell<I> of​(java.lang.String label)

      Returns the instance with the given label.
      Parameters:
        `label` - The label that the cell holds.

    - #### of

          static <I extends IAnyGroup> IListcell<I> of​(java.lang.String label,
                                                       java.lang.String image)

      Returns the instance with the given label and image.
      Parameters:
        `label` - The label that the cell holds.
        `image` - The image that the cell holds.

    - #### of

          static <I extends IAnyGroup> IListcell<I> of​(java.lang.Iterable<? extends I> children)

      Returns the instance with the given any group children.
      Parameters:
        `children` - The children belong to any group
      See Also:
        `IAnyGroup`

    - #### of

          static <I extends IAnyGroup> IListcell<I> of​(I... children)

      Returns the instance with the given any group children.
      Parameters:
        `children` - The children belong to any group
      See Also:
        `IAnyGroup`

    - #### ofImage

          static <I extends IAnyGroup> IListcell<I> ofImage​(java.lang.String image)

      Returns the instance with the given image.
      Parameters:
        `image` - The image that the cell holds.

    - #### ofId

          static <I extends IAnyGroup> IListcell<I> ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component